import { defineComponent as L, ref as p, watch as w, nextTick as A, onMounted as h, onBeforeUnmount as D, createBlock as T, openBlock as y, Transition as _, withCtx as M, withDirectives as N, createElementVNode as k, normalizeStyle as $, normalizeClass as m, withModifiers as B, createElementBlock as E, createCommentVNode as V, renderSlot as O, vShow as I } from "vue";
const P = ["open", "aria-describedby"], H = { role: "document" }, z = /* @__PURE__ */ L({
  __name: "HtmlDialog",
  props: {
    modelValue: Boolean,
    showBackdrop: { type: Boolean, default: !0 },
    closeOnBackdropClick: { type: Boolean, default: !0 },
    closeOnOutsideClick: { type: Boolean, default: !0 },
    closeOnEscape: { type: Boolean, default: !0 },
    showCloseButton: { type: Boolean, default: !0 },
    titleId: String,
    dialogClass: String,
    backdropClass: String,
    closeButtonClass: String,
    enterActiveClass: { type: String, default: "fade-enter-active" },
    leaveActiveClass: { type: String, default: "fade-leave-active" },
    transitionDuration: { type: Number, default: 300 }
  },
  emits: ["update:modelValue", "open", "close"],
  setup(d, { expose: f, emit: s }) {
    const o = d, a = p(null), n = p(o.modelValue), u = typeof HTMLDialogElement < "u", c = s;
    w(() => o.modelValue, (e) => {
      n.value = e;
    }), w(n, (e) => {
      c("update:modelValue", e), e && (c("open"), A(() => {
        var i;
        (i = a.value) == null || i.focus();
      }));
    }), w(n, (e) => {
      e ? (window.addEventListener("keydown", v), !o.showBackdrop && o.closeOnOutsideClick && document.addEventListener("mousedown", l)) : (window.removeEventListener("keydown", v), document.removeEventListener("mousedown", l));
    });
    function g() {
      var e;
      u && ((e = a.value) != null && e.showModal) ? a.value.showModal() : n.value = !0;
    }
    function r() {
      n.value = !1;
    }
    function C(e) {
      e.target === e.currentTarget && o.closeOnBackdropClick && r();
    }
    function t() {
      n.value = !1, c("update:modelValue", !1), c("close");
    }
    function l(e) {
      if (!a.value || !o.closeOnOutsideClick) return;
      const i = a.value, b = e.target;
      i.contains(b) || r();
    }
    function v(e) {
      e.key === "Escape" && o.closeOnEscape && r();
    }
    return h(() => {
      a.value && (n.value = a.value.open, a.value.addEventListener("close", t));
    }), D(() => {
      var e;
      window.removeEventListener("keydown", v), document.removeEventListener("mousedown", l), (e = a.value) == null || e.removeEventListener("close", t);
    }), f({
      openDialog: g,
      closeDialog: r
    }), (e, i) => (y(), T(_, {
      "enter-active-class": e.enterActiveClass,
      "leave-active-class": e.leaveActiveClass,
      onAfterLeave: i[1] || (i[1] = (b) => e.$emit("close"))
    }, {
      default: M(() => [
        N(k("div", {
          class: m(["backdrop", e.backdropClass]),
          onMousedown: C,
          role: "presentation",
          style: $({ "--transition-duration": e.transitionDuration + "ms" })
        }, [
          k("dialog", {
            ref_key: "dialogEl",
            ref: a,
            open: n.value,
            class: m(["dialog", e.dialogClass]),
            onPointerdown: i[0] || (i[0] = B(() => {
            }, ["stop"])),
            role: "dialog",
            "aria-modal": "true",
            "aria-describedby": e.titleId
          }, [
            k("div", H, [
              e.showCloseButton ? (y(), E("button", {
                key: 0,
                class: m(["close-button", e.closeButtonClass]),
                onPointerdown: B(r, ["prevent"]),
                "aria-label": "Close the modal"
              }, "×", 34)) : V("", !0),
              O(e.$slots, "default", {}, void 0, !0)
            ])
          ], 42, P)
        ], 38), [
          [I, n.value && e.showBackdrop]
        ])
      ]),
      _: 3
    }, 8, ["enter-active-class", "leave-active-class"]));
  }
}), S = (d, f) => {
  const s = d.__vccOpts || d;
  for (const [o, a] of f)
    s[o] = a;
  return s;
}, j = /* @__PURE__ */ S(z, [["__scopeId", "data-v-199be3ef"]]), F = { role: "document" }, K = /* @__PURE__ */ L({
  __name: "FullNativeDialog",
  props: {
    modelValue: Boolean,
    closeOnEscape: { type: Boolean, default: !0 },
    closeButton: { type: Boolean, default: !0 },
    dialogClass: String,
    closeButtonClass: String,
    enterActiveClass: { type: String, default: "fade-enter-active" },
    leaveActiveClass: { type: String, default: "fade-leave-active" },
    transitionDuration: { type: Number, default: 300 }
  },
  emits: ["update:modelValue", "open", "close"],
  setup(d, { emit: f }) {
    const s = d, o = p(null), a = p(!1), n = p(null), u = f;
    function c() {
      o.value && (o.value.open || (o.value.showModal(), u("update:modelValue", !0), u("open"), o.value.focus()));
    }
    function g() {
      !o.value || a.value || (a.value = !0, o.value.classList.add(s.leaveActiveClass), setTimeout(() => {
        var t, l;
        (t = o.value) == null || t.close(), a.value = !1, (l = o.value) == null || l.classList.remove(s.leaveActiveClass), u("update:modelValue", !1), u("close");
      }, s.transitionDuration));
    }
    w(
      () => s.modelValue,
      (t) => {
        var l;
        t ? (c(), n.value && clearTimeout(n.value), (l = o.value) == null || l.classList.add(s.enterActiveClass), n.value = window.setTimeout(() => {
          var v;
          (v = o.value) == null || v.classList.remove(s.enterActiveClass), n.value = null;
        }, s.transitionDuration)) : g();
      }
    );
    function r(t) {
      s.closeOnEscape || t.preventDefault();
    }
    function C() {
      u("update:modelValue", !1), u("close");
    }
    return h(() => {
      var t, l;
      (t = o.value) == null || t.addEventListener("cancel", r), (l = o.value) == null || l.addEventListener("close", C);
    }), D(() => {
      var t, l;
      (t = o.value) == null || t.removeEventListener("cancel", r), (l = o.value) == null || l.removeEventListener("close", C);
    }), (t, l) => (y(), E("dialog", {
      ref_key: "dialogEl",
      ref: o,
      class: m([t.dialogClass]),
      role: "dialog",
      onPointerdown: l[0] || (l[0] = B(() => {
      }, ["stop"])),
      "aria-modal": "true"
    }, [
      k("div", F, [
        t.closeButton ? (y(), E("button", {
          key: 0,
          class: m(["close-button", t.closeButtonClass]),
          onPointerdown: B(g, ["prevent"]),
          "aria-label": "Close dialog",
          type: "button"
        }, "×", 34)) : V("", !0),
        O(t.$slots, "default", {}, void 0, !0)
      ])
    ], 34));
  }
}), q = /* @__PURE__ */ S(K, [["__scopeId", "data-v-6fab06f2"]]);
export {
  q as FullNativeDialog,
  j as HtmlDialog
};
